
;Nautilus Engine v.1.00

Enumeration
  #NE_WINDOW_NORMAL
  #NE_WINDOW_SIZEABLE
  #NE_WINDOW_POPUP
  #NE_WINDOW_FULLSCREEN
EndEnumeration

CompilerIf  #PB_Compiler_Processor = #PB_Processor_x86
  Import "ne32.lib"
    nautilusCreate(hWnd.i,ScreenWidth.i = 320,ScreenHeight.i = 200,FPS.i = 60)
    nautilusWindow.i(Title.s,Width.i,Height.i,Type.i = #NE_WINDOW_NORMAL,ScreenWidth.i = 320,ScreenHeight.i = 200,FPS.i = 60)
    nautilusVersion.i()
  EndImport
CompilerElse
  Import "ne64.lib"
    nautilusCreate(hWnd.i,ScreenWidth.i = 320,ScreenHeight.i = 200,FPS.i = 60)
    nautilusWindow.i(Title.s,Width.i,Height.i,Type.i = #NE_WINDOW_NORMAL,ScreenWidth.i = 320,ScreenHeight.i = 200,FPS.i = 60)
    nautilusVersion.i()
  EndImport
CompilerEndIf

Structure NE_VECTOR
  x.f
  y.f
EndStructure

Structure NE_INDEX
  x.i
  y.i
EndStructure

Structure NE_CLAMP
  min.NE_INDEX
  max.NE_INDEX
EndStructure

Interface NAUTILUS_WORLD
  Tiles.i()
  TilesX.i()
  TilesY.i()
  TileWidth.i()
  TileHeight.i()
  CameraCreate.i(X.f,Y.i,Width.f,Height.f)
  CameraOrigin.i(Camera.i,*Origin,*Offset = #Null)
  CameraMove.i(Camera.i,*Move,*Offset = #Null)
  CameraIndex.i(Camera.i,*Index)
  CameraPosition.i(Camera.i,*Position)
  CameraClamp.i(Camera.i,TilesX.i = 2,TilesY.i = 2)
  CameraZoom.f(Camera.i,Min.f,Max.f,*Scale = #Null)
  CameraScale.f(Camera.i)
  CameraUpdate.i(Camera.i,*Clamp = #Null,*Translation = #Null)
  CameraDestroy.i(Camera.i)
  Mouse.i(Camera.i,*Mouse,*Position,*Index = #Null)
  WorldToScreen.i(Camera.i,*Input,*Output)
  ScreenToWorld.i(Camera.i,*Input,*Output)
  TileMapCreate.i()
  TileMapToScreen.i(Camera.i,X.i,Y.i,*Position,*Link = #Null)
  TileMapSet.i(X.i,Y.i,Link.i)
  TileMapGet.i(X.i,Y.i)
  TileMapDestroy.i()
  ProjectionFx.i(*Origin,*Target,*Position,Factor.f = 10)
  Release.i()
EndInterface

Interface NAUTILUS_LOGIC
  TestBox.i(X1.f,Y1.f,W1.f,H1.f,X2.f,Y2.f,W2.f,H2.f)
  TestBoxEx.i(*PosA,W1.f,H1.f,*PosB,W2.f,H2.f)
  TestSprite.i(X1.f,Y1.f,*SpriteA,X2.f,Y2.f,*SpriteB)
  TestSpriteEx.i(*PosA,*SpriteA,*PosB,*SpriteB)
  TestLine.i(*a,*b,*c,*d,*e)
  TestLineEx.i(*LineA,*LineB,*Offset)
  AStarMaskCreate.i(*Buffer,Width.i,Height.i)
  AStarMaskWidth.i(*Mask)
  AStarMaskHeight.i(*Mask)
  AStarMaskSet.i(*Mask,X.i,Y.i,Flag.b = #True)
  AStarMaskGet.i(*Mask,X.i,Y.i)
  AStarMaskFree.i(*Mask)
  AStarPathCreate.i(*Mask,*Start,*Stop,Diagonal.i = #False,Smooth.i = #False,Distance.i = #Null,Nodes.i = #Null) 
  AStarPath.i(*Path,*Offset)
  AStarPathGet.i(*Path)
  AStarPathSet.i(*Path,Node.i = #Null)
  AStarPathFree.i(*Path)
EndInterface

Interface NAUTILUS_FONT
  Width.f()
  Height.f()
  CenterX.f()
  CenterY.f()
  Resize.i(Width.f,Height.f)
  ResetSize.i()
  SpacingGet.f()
  SpacingSet.i(Spacing.f = #Null)
  SpacingRese.i()
  Draw.i(X.f,Y.f,Text.s,CenterX.i = #False,CenterY.i = #False,Alpha.a = #Null,Tint.i = #Null)
  DrawEx.i(X.f,Y.f,Text.s,CenterX.i = #False,CenterY.i = #False,Alpha.a = #Null,Angle.f = #Null,Tint.i = #Null)
  DrawMod.i(X.f,Y.f,Text.s,Width.f = #Null,Height.f = #Null,CenterX.i = #False,CenterY.i = #False,Alpha.a = #Null,Tint.i = #Null)
  DrawModEx.i(X.f,Y.f,Text.s,Width.f = #Null,Height.f = #Null,CenterX.i = #False,CenterY.i = #False,Alpha.a = #Null,Angle.f = #Null,Tint.i = #Null)
  Light.i(X.f,Y.f,Text.s,CenterX.i = #False,CenterY.i = #False,Tint.i = #Null)
  LightEx.i(X.f,Y.f,Text.s,CenterX.i = #False,CenterY.i = #False,Angle.f = #Null,Tint.i = #Null)
  LightMod.i(X.f,Y.f,Text.s,Width.f = #Null,Height.f = #Null,CenterX.i = #False,CenterY.i = #False,Tint.i = #Null)
  LightModEx.i(X.f,Y.f,Text.s,Width.f = #Null,Height.f = #Null,CenterX.i = #False,CenterY.i = #False,Angle.f = #Null,Tint.i = #Null)
  LayerDraw.i(Layer.i,X.f,Y.f,Text.s,CenterX.i = #False,CenterY.i = #False,Alpha.a = #Null,Tint.i = #Null)
  LayerDrawEx.i(Layer.i,X.f,Y.f,Text.s,CenterX.i = #False,CenterY.i = #False,Alpha.a = #Null,Angle.f = #Null,Tint.i = #Null)
  LayerMod.i(Layer.i,X.f,Y.f,Text.s,Width.f = #Null,Height.f = #Null,CenterX.i = #False,CenterY.i = #False,Alpha.a = #Null,Tint.i = #Null)
  LayerModEx.i(Layer.i,X.f,Y.f,Text.s,Width.f = #Null,Height.f = #Null,CenterX.i = #False,CenterY.i = #False,Alpha.a = #Null,Angle.f = #Null,Tint.i = #Null)
  LayerLight.i(Layer.i,X.f,Y.f,Text.s,CenterX.i = #False,CenterY.i = #False,Tint.i = #Null)
  LayerLightEx.i(Layer.i,X.f,Y.f,Text.s,CenterX.i = #False,CenterY.i = #False,Angle.f = #Null,Tint.i = #Null)
  LayerLightMod.i(Layer.i,X.f,Y.f,Text.s,Width.f = #Null,Height.f = #Null,CenterX.i = #False,CenterY.i = #False,Tint.i = #Null)
  LayerLightModEx.i(Layer.i,X.f,Y.f,Text.s,Width.f = #Null,Height.f = #Null,CenterX.i = #False,CenterY.i = #False,Angle.f = #Null,Tint.i = #Null)
  Release.i()
EndInterface

Interface NAUTILUS_SPRITE
  Width.f()
  Height.f()
  CenterX.f()
  CenterY.f()
  Resize.i(Width.f,Height.f)
  ResetSize.i()
  Draw.i(X.f,Y.f,Center.i = #False,Alpha.a = #Null)
  DrawEx.i(X.f,Y.f,Center.i = #False,Alpha.a = #Null,Angle.f = #Null,Tint.i = #Null)
  DrawMod.i(X.f,Y.f,Width.f = #Null,Height.f = #Null,Center.i = #False,Alpha.a = #Null)
  DrawModEx.i(X.f,Y.f,Width.f = #Null,Height.f = #Null,Center.i = #False,Alpha.a = #Null,Angle.f = #Null,Tint.i = #Null)
  DrawMap.i(X1.f,Y1.f,X2.f,Y2.f,X3.f,Y3.f,X4.f,Y4.f,Alpha.a = #Null)
  DrawMapEx.i(X1.f,Y1.f,X2.f,Y2.f,X3.f,Y3.f,X4.f,Y4.f,Alpha.a = #Null,AnchorX.f = #Null,AnchorY.f = #Null,Angle.f = #Null,Tint.i = #Null)
  Light.i(X.f,Y.f,Center.i = #False,Tint.i = #Null)
  LightEx.i(X.f,Y.f,Center.i = #False,Angle.f = #Null,Tint.i = #Null)
  LightMod.i(X.f,Y.f,Width.f = #Null,Height.f = #Null,Center.i = #False,Tint.i = #Null)
  LightModEx.i(X.f,Y.f,Width.f = #Null,Height.f = #Null,Center.i = #False,Angle.f = #Null,Tint.i = #Null)
  LightDrawMap.i(X1.f,Y1.f,X2.f,Y2.f,X3.f,Y3.f,X4.f,Y4.f,Alpha.a = #Null)
  LightDrawMapEx.i(X1.f,Y1.f,X2.f,Y2.f,X3.f,Y3.f,X4.f,Y4.f,Alpha.a = #Null,AnchorX.f = #Null,AnchorY.f = #Null,Angle.f = #Null,Tint.i = #Null)
  LayerDraw.i(Layer.i,X.f,Y.f,Center.i = #False,Alpha.a = #Null);14
  LayerDrawEx.i(Layer.i,X.f,Y.f,Center.i = #False,Alpha.a = #Null,Angle.f = #Null,Tint.i = #Null)
  LayerDrawMod.i(Layer.i,X.f,Y.f,Width.f = #Null,Height.f = #Null,Center.i = #False,Alpha.a = #Null)
  LayerDrawModEx.i(Layer.i,X.f,Y.f,Width.f = #Null,Height.f = #Null,Center.i = #False,Alpha.a = #Null,Angle.f = #Null,Tint.i = #Null)
  LayerDrawMap.i(Layer.i,X1.f,Y1.f,X2.f,Y2.f,X3.f,Y3.f,X4.f,Y4.f,Alpha.a = #Null)
  LayerDrawMapEx.i(Layer.i,X1.f,Y1.f,X2.f,Y2.f,X3.f,Y3.f,X4.f,Y4.f,Alpha.a = #Null,AnchorX.f = #Null,AnchorY.f = #Null,Angle.f = #Null,Tint.i = #Null)
  LayerLight.i(Layer.i,X.f,Y.f,Center.i = #False,Tint.i = #Null)
  LayerLightEx.i(Layer.i,X.f,Y.f,Center.i = #False,Angle.f = #Null,Tint.i = #Null)
  LayerLightMod.i(Layer.i,X.f,Y.f,Width.f = #Null,Height.f = #Null,Center.i = #False,Tint.i = #Null)
  LayerLightModEx.i(Layer.i,X.f,Y.f,Width.f = #Null,Height.f = #Null,Center.i = #False,Angle.f = #Null,Tint.i = #Null)
  LayerLightDrawMap.i(Layer.i,X1.f,Y1.f,X2.f,Y2.f,X3.f,Y3.f,X4.f,Y4.f,Alpha.a = #Null)
  LayerLightDrawMapEx.i(Layer.i,X1.f,Y1.f,X2.f,Y2.f,X3.f,Y3.f,X4.f,Y4.f,Alpha.a = #Null,AnchorX.f = #Null,AnchorY.f = #Null,Angle.f = #Null,Tint.i = #Null)
  Release.i()
EndInterface

Interface NAUTILUS_TILE
  Width.f()
  Height.f()
  CenterX.f()
  CenterY.f()
  Resize.i(Width.f,Height.f)
  ResetSize.i()
  Draw.i(Index.i,X.f,Y.f,Center.i = #False,Alpha.a = #Null)
  DrawEx.i(Index.i,X.f,Y.f,Center.i = #False,Alpha.a = #Null,Angle.f = #Null,Tint.i = #Null)
  DrawMod.i(Index.i,X.f,Y.f,Width.f = #Null,Height.f = #Null,Center.i = #False,Alpha.a = #Null)
  DrawModEx.i(Index.i,X.f,Y.f,Width.f = #Null,Height.f = #Null,Center.i = #False,Alpha.a = #Null,Angle.f = #Null,Tint.i = #Null)
  DrawMap.i(Index.i,X1.f,Y1.f,X2.f,Y2.f,X3.f,Y3.f,X4.f,Y4.f,Alpha.a = #Null)
  DrawMapEx.i(Index.i,X1.f,Y1.f,X2.f,Y2.f,X3.f,Y3.f,X4.f,Y4.f,Alpha.a = #Null,AnchorX.f = #Null,AnchorY.f = #Null,Angle.f = #Null,Tint.i = #Null)
  Light.i(Index.i,X.f,Y.f,Center.i = #False,Tint.i = #Null)
  LightEx.i(Index.i,X.f,Y.f,Center.i = #False,Angle.f = #Null,Tint.i = #Null)
  LightMod.i(Index.i,X.f,Y.f,Width.f = #Null,Height.f = #Null,Center.i = #False,Tint.i = #Null)
  LightModEx.i(Index.i,X.f,Y.f,Width.f = #Null,Height.f = #Null,Center.i = #False,Angle.f = #Null,Tint.i = #Null)
  LightDrawMap.i(Index.i,X1.f,Y1.f,X2.f,Y2.f,X3.f,Y3.f,X4.f,Y4.f,Alpha.a = #Null)
  LightDrawMapEx.i(Index.i,X1.f,Y1.f,X2.f,Y2.f,X3.f,Y3.f,X4.f,Y4.f,Alpha.a = #Null,AnchorX.f = #Null,AnchorY.f = #Null,Angle.f = #Null,Tint.i = #Null)
  LayerDraw.i(Layer.i,Index.i,X.f,Y.f,Center.i = #False,Alpha.a = #Null)
  LayerDrawEx.i(Layer.i,Index.i,X.f,Y.f,Center.i = #False,Alpha.a = #Null,Angle.f = #Null,Tint.i = #Null)
  LayerDrawMod.i(Layer.i,Index.i,X.f,Y.f,Width.f = #Null,Height.f = #Null,Center.i = #False,Alpha.a = #Null)
  LayerDrawModEx.i(Layer.i,Index.i,X.f,Y.f,Width.f = #Null,Height.f = #Null,Center.i = #False,Alpha.a = #Null,Angle.f = #Null,Tint.i = #Null)
  LayerDrawMap.i(Layer.i,Index.i,X1.f,Y1.f,X2.f,Y2.f,X3.f,Y3.f,X4.f,Y4.f,Alpha.a = #Null)
  LayerDrawMapEx.i(Layer.i,Index.i,X1.f,Y1.f,X2.f,Y2.f,X3.f,Y3.f,X4.f,Y4.f,Alpha.a = #Null,AnchorX.f = #Null,AnchorY.f = #Null,Angle.f = #Null,Tint.i = #Null)
  LayerLight.i(Layer.i,Index.i,X.f,Y.f,Center.i = #False,Tint.i = #Null)
  LayerLightEx.i(Layer.i,Index.i,X.f,Y.f,Center.i = #False,Angle.f = #Null,Tint.i = #Null)
  LayerLightMod.i(Layer.i,Index.i,X.f,Y.f,Width.f = #Null,Height.f = #Null,Center.i = #False,Tint.i = #Null)
  LayerLightModEx.i(Layer.i,Index.i,X.f,Y.f,Width.f = #Null,Height.f = #Null,Center.i = #False,Angle.f = #Null,Tint.i = #Null)
  LayerLightDrawMap.i(Layer.i,Index.i,X1.f,Y1.f,X2.f,Y2.f,X3.f,Y3.f,X4.f,Y4.f,Alpha.a = #Null)
  LayerLightDrawMapEx.i(Layer.i,Index.i,X1.f,Y1.f,X2.f,Y2.f,X3.f,Y3.f,X4.f,Y4.f,Alpha.a = #Null,AnchorX.f = #Null,AnchorY.f = #Null,Angle.f = #Null,Tint.i = #Null)
  Animation.i(Timer.f = #Null,Active.i = #True,Once.i = #False)
  AnimationState.i(Active.i = #True)
  AnimationOnce.i(Flag.i = #True)
  AnimationFrame.i()
  AnimationFrames.i()
  AnimationStart.i(Index.i = -1)
  AnimationStop.i(Index.i = -1)
  AnimationReset.i(Zero.i = #False)
  CreateCopy.i()
  Release.i()
EndInterface

Interface NAUTILUS_TEXTURE
  Pixel.i()
  PixelSize.i(*Bits)
  PixelGet.i(*Bits,X.i,Y.i)
  PixelSet.i(*Bits,X.i,Y.i,Color.i)
  PixelUpdate.i(X.i,Y.i,Width.i,Height.i,*Bits)
  PixelFree.i(*Bits)
  Bitmap.i(*Bitmap = #Null)
  Width.f()
  Height.f()
  CenterX.f()
  CenterY.f()
  Resize.i(Width.f,Height.f)
  ResetSize.i()
  Draw.i(X.f,Y.f,Center.i = #False,Alpha.a = #Null)
  DrawEx.i(X.f,Y.f,Center.i = #False,Alpha.a = #Null,Angle.f = #Null,Tint.i = #Null)
  DrawMod.i(X.f,Y.f,Width.f = #Null,Height.f = #Null,Center.i = #False,Alpha.a = #Null)
  DrawModEx.i(X.f,Y.f,Width.f = #Null,Height.f = #Null,Center.i = #False,Alpha.a = #Null,Angle.f = #Null,Tint.i = #Null)
  Light.i(X.f,Y.f,Center.i = #False,Tint.i = #Null)
  LightEx.i(X.f,Y.f,Center.i = #False,Angle.f = #Null,Tint.i = #Null)
  LightMod.i(X.f,Y.f,Width.f = #Null,Height.f = #Null,Center.i = #False,Tint.i = #Null)
  LightModEx.i(X.f,Y.f,Width.f = #Null,Height.f = #Null,Center.i = #False,Angle.f = #Null,Tint.i = #Null)
  LayerDraw.i(Layer.i,X.f,Y.f,Center.i = #False,Alpha.a = #Null)
  LayerDrawEx.i(Layer.i,X.f,Y.f,Center.i = #False,Alpha.a = #Null,Angle.f = #Null,Tint.i = #Null)
  LayerDrawMod.i(Layer.i,X.f,Y.f,Width.f = #Null,Height.f = #Null,Center.i = #False,Alpha.a = #Null)
  LayerDrawModEx.i(Layer.i,X.f,Y.f,Width.f = #Null,Height.f = #Null,Center.i = #False,Alpha.a = #Null,Angle.f = #Null,Tint.i = #Null)
  LayerLight.i(Layer.i,X.f,Y.f,Center.i = #False,Tint.i = #Null)
  LayerLightEx.i(Layer.i,X.f,Y.f,Center.i = #False,Angle.f = #Null,Tint.i = #Null)
  LayerLightMod.i(Layer.i,X.f,Y.f,Width.f = #Null,Height.f = #Null,Center.i = #False,Tint.i = #Null)
  LayerLightModEx.i(Layer.i,X.f,Y.f,Width.f = #Null,Height.f = #Null,Center.i = #False,Angle.f = #Null,Tint.i = #Null)
  CreateSprite.i(X.i,Y.i,Width.i,Height.i)
  CreateTile.i(CountX.i,CountY.i,X.i,Y.i,Width.i,Height.i,OffsetX.i = #Null,OffsetY.i = #Null)
  CreateFont.i(CountX.i,CountY.i,X.i,Y.i,Width.i,Height.i,OffsetX.i = #Null,OffsetY.i = #Null)
  Release.i()
EndInterface

Interface NAUTILUS_ENGINE
  Window.i()
  WindowTitle.i(Title.s)
  WindowIcon.i(*Icon)
  WindowRect.i(*Rect)
  WindowSize.i(*Vector)
  WindowCenter.i(*Vector)
  WindowExit.i()
  ScreenSize.i(*Vector)
  ScreenCenter.i(*Vector)
  ScreenFactor.i(*Vector)
  ScreenResize.i(Width.i,Height.i)
  ScreenResetSize.i()
  ScreenCursorClip.i(Flag.i = #True)
  ScreenCursorHide.i(Flag.i = #True)
  RenderAspect(Flag.i = #True)
  RenderFilter(Bilinear.i = #True)
  RenderColor(ColorABGR.i = #Null)
  RenderBegin.i(*Delta = #Null,*Frames = #Null)
  RenderClip.i(X.f,Y.f,Width.f,Height.f)
  RenderUnclip.i()
  RenderPush.i()
  RenderPop.i()
  RenderRotate.i(Angle.f)
  RenderScale.i(X.f,Y.f)
  RenderTranslate.i(X.f,Y.f)
  RenderReset.i()
  RenderEnd.i()
  DrawPointSize.i(Size.f = 1)
  DrawLineSize.i(Size.f = 1)
  DrawPoint.i(X.f,Y.f,ColorABGR.i = $FFFFFFFF)
  DrawCircle.i(X.f,Y.f,Radius.f,Fill.i = #False,ColorABGR.i = $FFFFFFFF)
  DrawLine.i(X1.f,Y1.f,X2.f,Y2.f,ColorABGR.i = $FFFFFFFF)
  DrawLineEx.i(X1.f,Y1.f,X2.f,Y2.f,C1.i = $FFFFFFFF,C2.i = $FFFFFFFF)
  DrawTriangle.i(X.f,Y.f,Width.f,Height.f,Fill.i = #False,ColorABGR.i = $FFFFFFFF)
  DrawTriangleEx.i(X.f,Y.f,Width.f,Height.f,Fill.i = #False,C1.i = $FFFFFFFF,C2.i = $FFFFFFFF,C3.i = $FFFFFFFF)
  DrawBox.i(X.f,Y.f,Width.f,Height.f,Center.i = #False,Fill.i = #False,ColorABGR.i = $FFFFFFFF)
  DrawBoxEx.i(X.f,Y.f,Width.f,Height.f,Center.i = #False,Fill.i = #False,C1.i = $FFFFFFFF,C2.i = $FFFFFFFF,C3.i = $FFFFFFFF,C4.i = $FFFFFFFF)
  DrawDiamond.i(X.f,Y.f,Width.f,Height.f,Center.i = #False,Fill.i = #False,ColorABGR.i = $FFFFFFFF)
  DrawDiamondEx.i(X.f,Y.f,Width.f,Height.f,Center.i = #False,Fill.i = #False,C1.i = $FFFFFFFF,C2.i = $FFFFFFFF,C3.i = $FFFFFFFF,C4.i = $FFFFFFFF)
  DrawTextWidth.f()
  DrawTextHeight.f()
  DrawTextResize.i(Width.f,Height.f)
  DrawTextResetSize.i()
  DrawTextGetSpacing.f()
  DrawTextSetSpacing.i(Spacing.f)
  DrawTextResetSpacing.i()
  DrawText.i(X.f,Y.f,Text.s,CenterX.i = #False,CenterY.i = #False,Alpha.a = #Null,Tint.i = #Null)
  DrawTextRot.i(X.f,Y.f,Text.s,CenterX.i = #False,CenterY.i = #False,Alpha.a = #Null,Angle.f = #Null,Tint.i = #Null)
  DrawTextMod.i(X.f,Y.f,Text.s,Width.f,Height.f,CenterX.i = #False,CenterY.i = #False,Alpha.a = #Null,Tint.i = #Null)
  DrawTextModEx.i(X.f,Y.f,Text.s,Width.f,Height.f,CenterX.i = #False,CenterY.i = #False,Alpha.a = #Null,Angle.f = #Null,Tint.i = #Null)
  DrawTextLight.i(X.f,Y.f,Text.s,CenterX.i = #False,CenterY.i = #False,Tint.i = #Null)
  DrawTextLightEx.i(X.f,Y.f,Text.s,CenterX.i = #False,CenterY.i = #False,Angle.f = #Null,Tint.i = #Null)
  DrawTextLightMod.i(X.f,Y.f,Text.s,Width.f,Height.f,CenterX.i = #False,CenterY.i = #False,Tint.i = #Null)
  DrawTextLightModEx.i(X.f,Y.f,Text.s,Width.f,Height.f,CenterX.i = #False,CenterY.i = #False,Angle.f = #Null,Tint.i = #Null)
  ListBegin.i()
  ListTexture.i(Flag.i = #False)
  ListMode.i(Mode.i)
  ListPushColor.i(ColorABGR.i = $FFFFFFFF)
  ListPushVertex.i(X.f,Y.f)
  ListPushPoint.i(X.f,Y.f,ColorABGR.i = $FFFFFFFF)
  ListPushCircle.i(X.f,Y.f,Radius.f,ColorABGR.i = $FFFFFFFF)
  ListPushLine.i(X1.f,Y1.f,X2.f,Y2.f,ColorABGR.i = $FFFFFFFF)
  ListPushLineEx.i(X1.f,Y1.f,X2.f,Y2.f,C1.i = $FFFFFFFF,C2.i = $FFFFFFFF)
  ListPushTriangle.i(X.f,Y.f,Width.f,Height.f,ColorABGR.i = $FFFFFFFF)
  ListPushTriangleEx.i(X.f,Y.f,Width.f,Height.f,C1.i = $FFFFFFFF,C2.i = $FFFFFFFF,C3.i = $FFFFFFFF)
  ListPushBox.i(X.f,Y.f,Width.f,Height.f,Center.i = #False,ColorABGR.i = $FFFFFFFF)
  ListPushBoxEx.i(X.f,Y.f,Width.f,Height.f,Center.i = #False,C1.i = $FFFFFFFF,C2.i = $FFFFFFFF,C3.i = $FFFFFFFF,C4.i = $FFFFFFFF)
  ListPushDiamond.i(X.f,Y.f,Width.f,Height.f,Center.i = #False,ColorABGR.i = $FFFFFFFF)
  ListPushDiamondEx.i(X.f,Y.f,Width.f,Height.f,Center.i = #False,C1.i = $FFFFFFFF,C2.i = $FFFFFFFF,C3.i = $FFFFFFFF,C4.i = $FFFFFFFF)
  ListModeEnd.i()
  ListEnd.i()
  ListDraw.i(ListId.i)
  ListLayer.i(Layer.i,ListId.i)
  ListFree.i(ListId.i)
  LayerPush(Layer.i)
  LayerPop(Layer.i)
  LayerRotate(Layer.i,Angle.f)
  LayerScale(Layer.i,X.f,Y.f)
  LayerTranslate(Layer.i,X.f,Y.f,Origin.i = #False)
  LayerReset(Layer.i)
  LayerDraw()
  InputKey.i(Code.i)
  InputKeySgl.i(Code.i)
  InputKeyChr.i(*Code)
  InputMouse.i(*Vector)
  InputMouseLeft.i()
  InputMouseLeftSgl.i()
  InputMouseLeftDbl.i()
  InputMouseRight.i()
  InputMouseRightSgl.i()
  InputMouseRightDbl.i()
  InputMouseMiddle.i()
  InputMouseMiddleSgl.i()
  InputMouseMiddleDbl.i()
  InputMouseWheel.i(Code.i = #Null,*Value.Integer = #Null)
  CreateTexture.i(*Buffer,File.s = #Null$)
  CreateTextureFont.i(*Buffer,File.s,CharWidth.i,CharHeight.i)
  CreateFont.i(*Buffer,BufferSize.i,FontName.s,Size.i = 12,Bold.i = #False,Italic.i = #False,ColorABGR.i = $FFFFFFFF)
  CreateLogic.i()
  CreateWorld.i(TilesX.i,TilesY.i,TileWidth.i,TileHeight.i)
  Release.i()
EndInterface

; IDE Options = PureBasic 5.62 (Windows - x64)
; CursorPosition = 36
; FirstLine = 22
; Folding = -
; EnableXP